package jsortdemo.algos;

/************************************************************************
  			BinaryInsertion.java - Copyright
**************************************************************************/

import jsortdemo.core.SortAlgo;

/**
 * Class BinaryInsertion.
 * <p>Project-Title: SortDemo --> Sortieralgorithmus BinaryInsertion</p>
 *
 * <p>Description: BinaryInsertion ist ein Sortieralgorithmus des 
 * SortDemo-Projektes.
 * Insertionsorts gehren zur Gruppe der elementaren Sortieralgorithmen.
 * Dieses Verfahren wird in der Regel auch zur Gruppe der Sortieralgorithmen
 * mit mittlerer Laufzeitkomplexitaet gezaehlt.
 * Der Name "Insertsort" kommt von insertion (dt. Einfgen), da in jedem Schritt
 * ein Element in eine bereits sortierte Gruppe von Elementen eingefgt wird</p>
 *
 * <p>Copyright: Copyright (c) 2004</p>
 *
 * <p>Company: </p>
 *
 * @see SortAlgo
 * @author Mathis Ahrens, Yvonne von Bischopinck
 * @version 1.1
 */
public class BinaryInsertion extends SortAlgo {

static int n; 
	
/**
 * Sortiert das Array nach dem BinaryInsertion-Algorithmus
 * @throws InterruptedException
 */
protected final void sort() throws InterruptedException {
	
	n = len;
	for (int i=0; i<len; i++){
		int x = get(i);
		int l = 0;
		int r = i;
		while (l<r){
			int m = ( (l+r)/2 );
			if ( comp(m,i) <= 0 ){
				l = m + 1;
			}else{
				r = m;
			}
	    	}
		
		for (int j=i; j>r ;j--) {
			// das vordere mit dem hinteren vertauschen
			swap(j, j-1);
		}
	// Werte zurueck ins Array schreiben
	put(r, x);
    }
}

}

