package jsortdemo.algos;

/************************************************************************
  			BubbleSort.java - Copyright 
**************************************************************************/

import jsortdemo.core.SortAlgo;

/**
 * Class BubbleSort.
 * <p>Project-Title: SortDemo --> Sortieralgorithmus BubbleSort</p>
 *
 * <p>Description: BubbleSort ist ein Sortieralgorithmus des 
 * SortDemo-Projektes.
 * Das Sortieren durch erfolgt durch Austauschen!
 * Bubblesort durchlaeuft das Array mehrmals von hinten nach vorn und laesst
 * durch paarweise Vergleiche das kleinste Element der restlichen Menge zum 
 * linken Ende des Arrays wandern. Stellt man sich das Array senkrecht angeordnet
 * vor, und die Elemente als Blasen, so steigt bei jedem Durchlauf durch das
 * Array eine Blase auf die ihrem Gewicht (Schluesselwert) entsprechende
 * Hoehe auf</p>
 *
 * <p>Copyright: Copyright (c) 2004</p>
 *
 * <p>Company: </p>
 *
 * @see SortAlgo
 * @author Mathis Ahrens, Yvonne von Bischopinck
 * @version 1.1
 */

public class BubbleSort extends SortAlgo {

/**
 * Sortiert das Array nach dem BubbleSort-Algorithmus
 * @throws InterruptedException
 */
protected final void sort() throws InterruptedException {

	boolean isSorted; // vorzeitiger Abbruch

	for (int i = len; i>0; i-- )
	{
		isSorted = true;

		for (int j = 1; j<i; j++) 
		{
			if ( comp(j-1,j) > 0 ) {
				// wenn Wert kleiner ist vertauschen
				swap(j-1,j);
				isSorted = false;
			}
		}

		if (isSorted) return;

	}

}

} // end of class

