package jsortdemo.algos;

/************************************************************************
  			ShakerSort.java - Copyright 
**************************************************************************/

import jsortdemo.core.SortAlgo;

/**
 * Class ShakerSort.
 *
 * <p>Project-Title: SortDemo --> Sortieralgorithmus ShakerSort</p>
 
 * <p>Description: ShakerSort ist ein Sortieralgorithmus des 
 * SortDemo-Projektes.
 * Beim ShakerSort wird der BubbleSort-Algorithmus so modifiziert, dass die 
 * Richtung des Schleifendurchlaufs bei jeder Iteration geaendert wird. Zunaechst wird 
 * also von unten nach oben, danach von oben nach unten usw. gesucht, 
 * in der Hoffnung, dass die Bubbles dann schneller ihre Position erreichen.
 * Die Hoffnung truegt allerdings, der neue Algorithmus ist in keiner Hinsicht 
 * besser als BubbleSort, er ist nur etwas komplizierter</p>
 *
 *
 * <p>Copyright: Copyright (c) 2004</p>
 *
 * <p>Company: </p>
 *
 * @see SortAlgo
 * @author Mathis Ahrens, Yvonne von Bischopinck
 * @version 1.1
 */ 
public class ShakerSort extends SortAlgo {

static int n; 
	
/**
 * Sortiert das Array per ShakerSort
 * @throws InterruptedException
 */
protected final void sort() throws InterruptedException{

	n = len;
	int l = 1;
    	int r = len-1;
	int k = r;
	
	boolean sorted = false; 
	
	while (!sorted) {
		for (int j = r; j >= l; j--){
			int j1 = j-1;
	    		if ( comp(j1,j) > 0) {
				swap(j1,j);
				k = j;
	    		}
		}

		l = k + 1;

		for ( int j = l; j <= r; j++) {
	    		int j1 = j-1;
	    		if ( comp(j1, j) > 0 ){
				swap (j1,j);
				k = j;
	    		}
		}

		r = k - 1;
		sorted = (l > r);
	}
}
}
