package jsortdemo.algos;

/************************************************************************
  			ShellSort.java - Copyright 
**************************************************************************/

import jsortdemo.core.SortAlgo;

/**
 * Class ShellSort.
 *
 * <p>Project-Title: SortDemo --> Sortieralgorithmus ShellSort</p>
 
 * <p>Description: HeapSort ist ein Sortieralgorithmus des 
 * SortDemo-Projektes.
 * ShellSort ist ein von Donald L. Shell im Jahre 1959 entwickelter Sortieralgorithmus,
 * der auf dem Sortieralgorithmus des direkten Einfuegens (Insertionsort) basiert.
 * Der Gedanke, der hinter ShellSort steht kann wie folgt beschrieben werden:
 * Die Daten werden in eine zweidimensionale Matrix geschrieben 
 * Die Spalten der Matrix werden einzeln sortiert 
 * Daraus resultiert eine grobe Sortierung. Dieser Schritt wird oefters wiederholt,
 * wobei jeweils die Breite der Matrix verringert wird, bis die Matrix nur
 * noch aus einer einzigen vollstaendig sortierten Spalte besteht.
 * ShellSort arbeitet instabil und in-place.</p>
 *
 * <p>Copyright: Copyright (c) 2004</p>
 *
 * <p>Company: </p>
 *
 * @see SortAlgo
 * @author Mathis Ahrens, Yvonne von Bischopinck
 * @version 1.1
 */ 
public class ShellSort extends SortAlgo {

private static int n;

/**
 * Initialisiert die Laenge und ruft Shellsort() auf
 * @throws InterruptedException
 */
protected final void sort() throws InterruptedException{
	n=len;
	shellsort();
}


/**
 * Sortiert das Array nach dem Shellsort-Algo
 * @throws InterruptedException
 */
protected final void shellsort() throws InterruptedException{
	int i, j, k, h, t;
	int cols[] = {len, len/2, len/4, len/8, len/16, 2,1};
	for (k=0; k<7; k++){
		h=cols[k];
		for (i=h; i<n; i++){
			j=i;
			t=get(j);
			while (j>=h && (compVal(get(j-h), t)>0) ){
				put(j,get(j-h));// ins Array einfuegen
				j=j-h;
			}
			put(j,t);//ins Array einfuegen
		}
	}
}

} // end of class

