package jsortdemo.algos;

/*************************************************************************
*     			StraightInsertion.java - Copyright 
**************************************************************************/

import jsortdemo.core.SortAlgo;

/**
 * Class StraightInsertion.
 *
 * <p>Project-Title: SortDemo --> Sortieralgorithmus StraightInsertion</p>
 
 * <p>Description: StraightInsertion ist ein Sortieralgorithmus des 
 * SortDemo-Projektes.
 * Jedes Element, das vor dem betrachtetem Element steht und groesser als dieses ist,
 * wird um eine Position nach hinten verschoben. In die freigewordene Stelle wird
 * dann das urspruenglich betrachtete Element eingefuegt. Wenn alle Elemente 
 * von vorne nach hinten einmal betrachtet, ist das Feld sortiert</p>
 *
 *
 * <p>Copyright: Copyright (c) 2004</p>
 *
 * <p>Company: </p>
 *
 * @see SortAlgo
 * @author Mathis Ahrens, Yvonne von Bischopinck
 * @version 1.1
 */ 
  
public class StraightInsertion extends SortAlgo {   
    
private static int n;
    
/**
 * Initialisiert die Laenge und ruft insertionsort() auf
 * @throws InterruptedException
 */
protected final void sort() throws InterruptedException{
	n=len;
	insertionsort();
}

/**
 * Sortiert das Array nach dem insertionSort-Algo
 * @throws InterruptedException
 */
protected final void insertionsort() throws InterruptedException{
        
	int i, j, t;
        for (i= 1; i<n; i++) {
		j=i;
		t=get(j);
		while (j > 0 && compVal(get(j-1),t) > 0) {
			put(j,get(j-1));
			j--;
		}
		put(j,t);
	}
}

}    // end class StraightInsertion 
