package jsortdemo.algos;

/************************************************************************
  			StraightSelection.java - Copyright 
**************************************************************************/

import jsortdemo.core.SortAlgo;

/**
 * Class StraightSelection.
 * <p>Project-Title: SortDemo --> Sortieralgorithmus StraightSelection</p>
 *
 * <p>Description: StraightSelection ist ein Sortieralgorithmus des 
 * SortDemo-Projektes.
 * StraightSelection ist eine Art Bubble-Sort, allerdings wandern hier die 
 * kleinen Zahlen nach vorne. Der Algorithmus durchlaeuft das Array von 0 bis n-1.
 *.und sucht zunaechst das kleinste Element im gesamten Feld und vertauscht es 
 * dann mit dem ersten Element. Dann sucht es das Zweitkleinste und vertauscht 
 * es mit Element 2. Das wird solange durchgefuehrt, bis das Feld sortiert ist</p>
 *
 * <p>Copyright: Copyright (c) 2004</p>
 *
 * <p>Company: </p>
 *
 * @see SortAlgo
 * @author Mathis Ahrens, Yvonne von Bischopinck
 * @version 1.1
 */
public class StraightSelection extends SortAlgo {

static int n; 
	
/**
 * Sortiert das Array nach dem StraightSelection-Algorithmus
 * @throws InterruptedException
 */
protected final void sort() throws InterruptedException{
    
    n=len;
    for (int i=0; i < (len-1); i++){
	int k = i;
	int x = get(i);

	for (int j = i+1; j < len; j++){

	    if ( compVal(get(j), x) < 0) {
		k = j;
		x = get(k);
	    }
	}

	swap(k,i);
}
}

}

