package jsortdemo.core;

/************************************************************************
  ParamView.java - Copyright 
 **************************************************************************/


import java.util.*;
import java.awt.*;
import javax.swing.*;

/**
 * Class ParamView.
 * <p>Project-Title: SortDemo --> ParamView</p>
 *
 * <p>Description: ParamView ist die Klasse im Projekt SortDemo, die fuer das
 * Zeichnen der Counter im Applet zustaendig ist.
 * Aus diesem Grund erweitert sie JPanel und implementiert Observer</p>
 *
 *
 * <p>Copyright: Copyright (c) 2004</p>
 *
 * <p>Company: </p>
 *

 * @author Mathis Ahrens, Yvonne von Bischopinck
 * @version 1.1
 */
public class ParamView extends JPanel implements Observer {

// Fields
protected SortModel model;

//4 neue label
JLabel countLabel[] = new JLabel[SortModel.MAXOP];
JPanel countPanel = new JPanel();

//JLabel algoLabel = new JLabel("", JLabel.TRAILING);
//JLabel algoLabel = new JLabel();

//labelnamen als stringarray
final static String[] TEXTPREFIX = {
	"Reads: ",
	"Writes: ",
	"Compares: ",
	"Swaps: "
};

// Methods
// Constructors
/**
 * Konstruktor.Erstellt neue Label und fuegt Observer zum Modell hinzu um auf 
 * Aenderungen reagieren zu koennen
 * @param m Das zugrundeliegende Sortiermodell mit Algo, GRoesse etc...
 */
public ParamView( SortModel m ) {

	model = m;

	BorderLayout bl = new BorderLayout();
	bl.setVgap(0);
	setLayout(bl);

	for (int i=0; i<SortModel.MAXOP; i++) {
		countLabel[i] = new JLabel();
		countPanel.add( countLabel[i] );
	}
	add( countPanel );

/*	add( algoLabel, BorderLayout.EAST );

        GridBagLayout gbLayout = new GridBagLayout();
	GridBagConstraints c = new GridBagConstraints();
        setLayout( gbLayout );

	c.gridx=0;
	c.weightx=1.0;
	c.fill=GridBagConstraints.NONE;
	c.anchor=GridBagConstraints.WEST;
	add( new JPanel(), c );	

	c.gridx=1;
	c.weightx=1.0;
	c.fill=GridBagConstraints.HORIZONTAL;
	c.anchor=GridBagConstraints.CENTER;
	add( countPanel, c );

	c.gridx=2;
	c.weightx=1.0;
	c.fill=GridBagConstraints.NONE;
	c.anchor=GridBagConstraints.EAST;
	add( algoLabel, c );
	*/

	update(null,null);

	model.addObserver(this);
}

	
/**
 * showCounts setzt die Namen der Label und fuegt die aktuelle Count-Anzahl hinzu
 * @return void
 */
 private void showCounts()
{
	for (int i=0; i<SortModel.MAXOP; i++) 
		countLabel[i].setText( TEXTPREFIX[i] + model.opCount[i] );
}

/**
 * showAlgo setzt den Namen des Algorithmus
 * @return void
 */
 private void showAlgo()
{
	//algoLabel.setText( model.getAlgoName() );
}

/*
public Dimension getPreferredSize() {
	return new Dimension( getRootPane().getSize().width, super.getPreferredSize().height );
}

public Dimension getMinimumSize() {
	return new Dimension( getRootPane().getSize().width, algoLabel.getPreferredSize().height );
}
*/

/**
 * update startet das Neuzeichnen der Werte falls ein update anliegt
 * @param o Das Objekt, nach dessen Ende alles upgedated werden soll
 * @param arg Von Observer vorgeschriebener Parameter, der hier aber nicht ausgelesen wird
 * @return void
 */
public void update( Observable o, Object arg ) {
	showCounts();	
	showAlgo();
	repaint();

}

} // end of class ParamView

